/*
Copyright 2022, Savanni D'Gerinel <savanni@luminescent-dreams.com>

This file is part of Savanni's AVR library.

This AVR library is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

This AVR library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this AVR library. If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef __PACKET_H__
#define __PACKET_H__

#include <stdint.h>
#include <stdlib.h>
#include <stdbool.h>

typedef enum {
    packet_type_data,
    packet_type_ack,
    packet_type_retry,
} packet_type_e;

typedef struct {
    packet_type_e type;
    uint16_t count;
    uint8_t sender;
    uint8_t receiver;
    size_t length;
    char message[60];
} packet_t;

#endif

